#! /usr/bin/env python

# analyzeSuboptimalEnergyOfTRNAs.py
# P. Clote, Sep 2003

#WARNING: This program calls the program "stats.py"

import sys,os
from stats import getStats


if len(sys.argv) != 2:
  print "Usage: %s file" % sys.argv[0]
  sys.exit(1)
num  = 0 #number of tRNA files
kNumBP = {}
kEnergy = {}
kNumSubOpt = {}
density    = {}
maxLevel    = 0  #largest level of any subopt str
sumMaxK     = 0  #sum of max suboptimal level


file = open(sys.argv[1])
line = file.readline()
while line:
  tmpfile = open("tmp","w")
  FASTAcomment = line
  tmpfile.write(FASTAcomment)
  tRNA = file.readline()
  tmpfile.write(tRNA)
  tmpfile.close()
  cmd  = "./a.out -f tmp"
  foo  = os.popen(cmd,"r")
  k    = 0 #counter for level of suboptimality
  num     += 1 #number of tRNA files
  line = foo.readline()
  LsubOpt = [] #list of number of subopt str for fixed RNA
  while line:
    words = line.split()
    assert (k == int(words[1]))
    if k>maxLevel: maxLevel = k
    numBP = int(words[3])
    if k in kNumBP.keys():
      kNumBP[k].append(numBP)
    else:
      kNumBP[k] = [numBP]
    line      = foo.readline()
    words  = line.split()
    numSubOpt = float(words[4]) 
    if k in kNumSubOpt.keys():
      kNumSubOpt[k].append(numSubOpt)
    else:
      kNumSubOpt[k] = [numSubOpt]
    LsubOpt.append( numSubOpt )
    line = foo.readline()
    line = foo.readline()
    words = line.split()
    energy = words[-1]
    energy = energy.strip()
    if energy[0]=='(': energy = energy[1:]
    if energy[-1]==')': energy = energy[:-1]
    energy = float(energy)
    if k in kEnergy.keys():
      kEnergy[k].append(energy)
    else:
      kEnergy[k] = [energy]
    k       += 1 #increment level of optimality
    line = foo.readline()

  foo.close()
  totalSubOpt = 0.0
  for x in LsubOpt: totalSubOpt += x
  for i in range(len(LsubOpt)):
    if i not in density.keys(): density[i] = 0.0
    density[i] += LsubOpt[i]/totalSubOpt
    
  sumMaxK   += maxLevel #sum of max suboptimal level
  line = file.readline() #get new RNA to process

#Now print statistics
print "Number of tRNA files: %d" % num
print "Maximum level of suboptimality: %d" % maxLevel    
avgMaxLevel = float(sumMaxK)/num

print "Stats for number of bp of optimal str for these RNA's"
(mean,stdev,max,min) = getStats(kNumBP[0])
print "Mean: %.2f\tStDev: %.2f\tMax: %d\tMin: %d\n" % (mean,stdev,max,min)

print "\nStats for mfe for suboptimal str for these RNA's"
keys = kEnergy.keys()
keys.sort()
print "k \tMean\tStDev\tMax\tMin\n"
for key in keys:
  (mean,stdev,max,min) = getStats(kEnergy[key])
  print "%d\t%.2f\t%.2f\t%.0f\t%.0f" % (key,mean,stdev,max,min)

print "\nStats for number of suboptimal str for these RNA's"
keys = kNumSubOpt.keys()
keys.sort()
print "k \tMean\tStDev\tMax\tMin\n"
for key in keys:
  (mean,stdev,max,min) = getStats(kNumSubOpt[key])
#  print "%d\t%.2f\t%.2f\t%.0f\t%.0f" % (key,mean,stdev,max,min)
  print "%d\t%G\t%G\t%G\t%G" % (key,mean,stdev,max,min)


print "\nDensity values\n"
keys = density.keys()
keys.sort()
sum = 0.0  #check that sum of all densities is 1
for key in keys:
  density[key] = density[key]/num #average density
  print "%d\t%f" % (key,density[key])
  sum += density[key]
print "Sum of density values: %f" % sum

