
/*----------------------
exampleCalloc.c
P. Clote Jul 2004
This program illustrates how to implement a multidimensional array
using pointers and nested calls of calloc. It is horribly slow for
large arrays. For that reason, it is preferred to use a single call
to calloc together with appropriate macro definitions to index into
the single dimensional array as if it were multidimensional.
----------------------*/

#include <stdio.h>

#define A 2
#define B 3
#define C 4

main(){
  int i,j,k,x=0;
  int ***M;
  for (i=0;i<A;i++) M = (int***) calloc(A,sizeof(int)); 
  for (i=0;i<A;i++) 
    for (j=0;j<B;j++)
      M[i] = (int**) calloc(B,sizeof(int)); 
  for (i=0;i<A;i++) 
    for (j=0;j<B;j++)
      for (k=0;k<C;k++)
        M[i][j] = (int*) calloc(C,sizeof(int)); 
  for (i=0;i<A;i++) 
    for (j=0;j<B;j++)
      for (k=0;k<C;k++){
        x++;
        M[i][j][k] = x;
        }
  for (i=0;i<A;i++) 
    for (j=0;j<B;j++)
      for (k=0;k<C;k++){
        printf("%d,%d,%d:%d\n",i,j,k,M[i][j][k]);
        }

  printf("hi\n");
}
